$sans-serif: "Avenir", sans-serif;

@font-face {
  font-family: "prodotto_in_cina";
  src: font-url("prodotto_in_cina-webfont.woff2") format("woff2"),
    font-url("prodotto_in_cina-webfont.woff") format("woff");
  font-weight: normal;
  font-style: normal;
}

@mixin code-text {
  font-family: "Monaco";
}

@mixin punk-text {
  font-family: "prodotto_in_cina";
  text-transform: uppercase;
}

// Mobile stuff is at the bottom

body {
  margin: 0;
  a {
    color: #ff4d71;
    &:visited {
      color: #a53148;
    }
    &.no_hot_pink {
      color: black;
    }
  }

  > .home-header {
    display: flex;
    justify-content: space-between;
    padding: 40px;
    img {
      position: relative;
      top: 4px;
      margin-right: 4px;
    }
  }

  > header {
    p {
      display: none;
    }
    background-size: 268px 100%;
    height: 268px;
    background-image: url("/images/title-background.png");
    text-align: center;

    > a img {
      width: 490px;
      height: 118px;
      margin: 45px auto;
      margin-bottom: 4px;
    }

    > nav li {
      @include punk-text;
      display: inline-block;
      font-size: 42px;
      margin: 0 20px;

      &.small {
        display: none;
      }
      &.big {
        display: inline-block;
      }

      a {
        &:visited {
          color: white;
        }

        text-decoration: none;
        color: white;
        text-shadow: 2px 2px black;

        &.highlighted,
        &:hover {
          color: #ffec00;
        }
        &.highlighted {
          cursor: default;
        }
      }
    }

    &.small {
      text-align: left;
      background-size: 67px 100%;
      height: 67px;
      margin-top: 20px;

      img {
        margin-left: 80px;
        margin-top: 20px;
        margin-bottom: -4px;
        width: 122px;
        height: 30px;
      }

      > nav {
        display: inline-block;
        ul {
          margin-left: 40px;
        }
        li {
          font-size: 28px;
          margin: 0 10px;
          a {
            text-shadow: 2px 2px black;
          }
        }
      }
    }
  }

  section.search_info ul,
  .selectors ul {
    margin-top: 10px;
    margin-bottom: 20px;
    padding: 0;

    & > li:first-child {
      margin-left: 0;
    }

    li {
      @include punk-text;
      font-size: 20px;
      background-color: #fffdd2;
      padding: 10px 20px;
      border-radius: 8px;
      margin-right: 20px;
      margin-bottom: 18px;
      display: inline-block;
      cursor: pointer;

      &.highlighted {
        background-color: #ffc449;
      }
    }
  }

  p,
  li {
    font-family: $sans-serif;
    font-size: 17px;
  }

  p > code {
    @include code-text;
    font-size: 14px;
    background-color: rgba(201, 167, 40, 0.1);
    word-break: break-all;
  }

  .highlight > pre {
    border-left: none;
    padding: 0px;
  }
  pre {
    border-left: solid 2px #4dff95;
    padding-left: 18px;
    border-bottom-left-radius: 20px;
  }
  code {
    @include code-text;
    font-size: 14px;
    > span.subtle {
      &.return::before {
        content: " -> ";
      }
      -webkit-user-select: none;
      -moz-user-select: none;
      color: #aaa;
    }
  }

  // The "created by ..." message
  .byline {
    text-align: right;
    display: block;
    margin-right: 20px;
    margin-top: 24px;
    margin-bottom: 24px;
    &.inline {
      font-size: 16px;
      display: inline-block;
      margin-top: 16px;
      margin-bottom: 0;
      margin-left: 16px;
    }
  }

  h2.punk {
    @include punk-text;

    margin-top: 80px;
    font-size: 48px;
    padding-left: 80px;
    background-color: #ffec00;
    min-height: 48px;

    &.reduced_top_margin {
      margin-top: 32px;
    }

    > span {
      padding-left: 10px;
      padding-right: 20px;
      padding-top: 6px;
      padding-bottom: 4px;
      background-color: white;
      display: inline-block;
    }
  }

  li {
    margin-bottom: 10px;
  }

  section {
    display: -ms-flex;
    display: -webkit-flex;
    display: flex;
    flex-flow: row;

    h3 {
      @include punk-text;
      font-size: 20px;
      text-transform: uppercase;
    }

    h4,
    h3 > span,
    h5 {
      font-family: $sans-serif;
      font-weight: 600;
      font-size: 20px;
      text-transform: uppercase;
    }

    h5 {
      font-size: 14px;
    }

    .header-link {
      @include code-text;
      text-decoration: none;
      color: #ffec00;

      &:hover {
        color: black;
      }
    }

    & > article:first-child {
      margin-right: 20px;
      margin-left: 80px;
    }

    article {
      flex: 1;
      width: 0;

      margin-right: 80px;
      margin-left: 20px;

      &.scope_code {
        font-size: 16px;
        h4 {
          font-size: 14px;
          margin-bottom: 0px;
        }
        .highlight {
          max-width: 100%;
          overflow-x: scroll;

          pre {
            margin-top: 4px;
            word-break: letter;
          }
        }
        ul li {
          @include code-text;
          font-size: 12px;
          color: #848684;
        }
      }

      code > blockquote {
        margin: 0;
      }

      div.fake_code > p {
        @include code-text;
        font-size: 14px;
        color: #848684;
        margin-bottom: 0px;
      }
    }
  }

  table {
    font-family: $sans-serif;
    font-weight: 400;
    font-size: 17px;
    width: 100%;
    thead tr th {
      border-bottom: 1px solid black;
    }
    tr td {
      text-align: center;
      padding: 10px 10px;
      border-bottom: 1px solid lightgrey;
    }
    tr td:first-child {
      text-align: left;
    }
  }

  .clearfix {
    clear: both;
  }

  > section.guide {
    img {
      max-width: 100%;
    }

    // To left align the edge, taking into account the link
    h3,
    h4,
    h5 {
      margin-left: -0.7em;
    }

    pre {
      max-width: 100%;
      overflow-x: scroll;
    }
  }

  > section.examples {
    ul {
      padding-left: 88px;
      margin-top: 0;
      min-width: 320px;
      a {
        text-decoration: none;
        color: black;
        &:hover {
          color: #ffec00;
        }
        span {
          font-family: $sans-serif;
          font-weight: bold;
          color: black;
          padding-left: 2px;
          padding-right: 3px;
        }
      }

      > li {
        @include punk-text;
        font-size: 20px;
        text-transform: uppercase;
        padding-top: 6px;
        padding-bottom: 6px;
        list-style-type: none;
      }

      > li.highlighted,
      > li.highlighted a {
        color: #ffc54d;
        list-style-type: disc;

        &:hover {
          cursor: default;
        }
      }
    }

    > div {
      -webkit-flex: 1;
      flex: 1;
      margin-right: 88px;
      overflow-x: scroll;
      margin-left: 30px;
    }

    .code_chunk {
      border: 1px solid #d4d4d4;
      display: block;
      margin: 0;
      padding: 10px;
      padding-left: 20px;
      line-height: 1.5;
      font-size: 16px;
      overflow-x: scroll;
    }

    ref {
      padding-top: 10px;
      @include code-text;
    }
  }

  footer {
    margin-top: 80px;
    background-color: #ffec00;
    display: -ms-flex;
    display: -webkit-flex;
    display: flex;
    flex-flow: row;
    padding-top: 40px;
    padding-bottom: 40px;
    & > article:first-child {
      margin-right: 20px;
      margin-left: 80px;
    }
    & > article:last-child {
      margin-right: 80px;
      text-align: right;
    }
    article {
      width: 25%;
    }
    h3 {
      @include punk-text;
    }

    ul {
      padding-left: 0;
      li {
        @include code-text;
        margin: 4px;
        list-style: none;
        a,
        a:visited {
          text-decoration: none;
          color: black;
        }
        a:hover {
          color: #867c01;
        }
      }
    }

    img.lang-logo {
      margin-right: 6px;
      position: relative;
      top: 1px;
    }
  }
}

// Make sure that the titles are always on one line

@media screen and (max-width: 960px) {
  body > header > nav li {
    font-size: 30px;
  }
}
// Alright, so the decision is that anything under 850px is "too small" aka mobile mode

@media screen and (max-width: 849px) {
  body section,
  body footer {
    // Columns of articles, not rows
    flex-flow: column;

    // Make all of the articles align
    article {
      width: 80%;
      margin-right: 20px;
      margin-left: 80px;
    }
  }

  // Different nav items, and smaller fonts
  body > header > nav li {
    font-size: 36px;
    margin: 0 10px;

    &.small {
      display: inline-block;
    }
    &.big {
      display: none;
    }
  }
  // Going bold, links are in the footer.
  body > header.small > nav {
    display: none;
  }

  // Danger's image is centered
  body footer > article:last-child {
    margin: 20px 0;
    width: 100%;
    text-align: center;
  }

  // Make select-y code bits most edge to edge
  body > section.examples > div {
    margin-right: 20px;
    margin-left: 20px;
  }

  // Kill the made by x, y
  body h2.reduced_top_margin .byline {
    display: none;
  }

  // Header fits mobile now
  body > header img {
    width: 373px;
    height: 90px;
    margin-top: 60px;
  }
}

article.plugin {
  h1 {
    @include punk-text;
    font-size: 2em;
  }
  h2 {
    @include punk-text;
    font-size: 1.5em;
  }
  table,
  img {
    max-width: 800px;
  }
  table td {
    text-align: left;
    padding: 2px 2px;
  }
}
